//externe Pakete
#include <SPI.h>
#include <SD.h>

//rote LED an D3; blaue an D6; Sonde an pinO2 anschließen
int           pinLedRot = 3,
              pinLedBlau = 6,
              pinO2 = A0,
              pinTemp = A1,
              pinLuefter = 9;

//alle anderen Variablen
int           messwert,
              messModus = 0,
              blauHoch = 1,
              rotHoch = 0,
              messung = 0,
              lueften = 0,
              luefterProzent,
              zustand,
              versuchsdauer,  //11 Einstellungen aus der config.txt zur Versuchsdurchführung
              frequenz = 3,
              temp_start,
              temp_zuwachs,
              temp_intervall,
              lichtinten_rot_start = 0,
              lichtinten_rot_zuwachs = 10,
              lichtinten_rot_intervall = 10,
              lichtinten_blau_start = 0,
              lichtinten_blau_zuwachs = 10,
              lichtinten_blau_intervall = 4;


unsigned long zeit,
         startzeit,
         messzeit,
         zeitletzte = 0,
         zeitsekunden;

//Messwerte
float         wertO2,
              wertTemp;

float         mittelwert,
              volt,
              ledRot,
              ledBlau,
              ledRotMin = 255,    //maximalwert Volt
              ledBlauMin = 255,
              alterMesswert = 9999,
              minuten = 5.0,
              faktorRot = 0.99,
              faktorBlau = 0.99;

String        dateiname = "config.txt",
              quellDatei;
boolean       rotLetzte = false,
              blauLetzte = false;

File          meineDatei;

void setup() {
  Serial.begin(115200);

  //Pins festlegen
  pinMode(pinO2, INPUT);
  pinMode(pinTemp, INPUT);

  pinMode(pinLuefter, OUTPUT);

  //wartet auf den Anschluss des Serial Ports
  while (!Serial) {
    ;
  }

  //Initialisierung der SD-Karte
  Serial.print(F("Initialisierung der SD Karte..."));
  if (!SD.begin(4)) {
    Serial.println(F("Initialisierung fehlgeschlagen!"));
    return;
  }
  Serial.println(F("Initialisierung durchgefuehrt."));
}


void loop() {
  delay(100);
  zeit = millis() / 1000; //Zeit seit Programmstart in Sekunden
  messzeit=zeit-startzeit;
  //Ansteuerungsschleife
  if (Serial.available() >= 1) {
    inByte = Serial.read();
    switch (inByte) {
      case 'a': //Messbedingungs-daten werden auf datei gespielt
        dateiname = Serial.readStringUntil(32);
        if (dateiname == " ")dateiname = "config.txt";
        einstellungenSpeichern(dateiname);
        break;
      case 'b':
        startzeit=millis()/1000;
        messzeit = 0;
        messModus = 1;
        Serial.println(F("Messung wurde gestartet: Messen00"));
        break;
      case 'c':
        messzeit =0;
        messModus = 2;
        Serial.println(F("Messung wurde gestartet: Messen01"));
        break;
      case 'd': // bestimmte datei wird nach processing geschickt
        if (Serial.available() > 0) {
          quellDatei = Serial.readString();
          //Serial.print(quellDatei);
          //Serial.println(F(" wird nun an Processing geschickt."));
          SDzuProcessing(quellDatei);
        } else {
          Serial.println(F("benenne Datei, die kopiert werden soll"));
        }
        break;
      case 'e':
        messModus = 0; //messung wird gestoppt
        messen00stop(); // setzt einige booleans auf false, die bei messen00 benutzt werden, damit das prg mit starten, neu starten kann
        break;
    }
  }

  // Messmethode auswählen
  switch (messModus) {
    case 1:
      messen00();     //reine Messung und speichern in Stufen
      break;
    case 2:
      messen01();     //Messen von O2 in Abhängigkeit von Licht
      break;
  }
  if (lueften == 1) { //wenn gelüftet werden soll, wird die Lüftersteuerung aufgerufen
    lueftersteuerung(luefterProzent);
  }

}
